#ifndef FRAME_H
#define FRAME_H

#include <inttypes.h>
enum transition {NONE, CUT, GRADUAL};

class frame
{
 public:
  frame(double time, unsigned char *img, int width, int height,
        int frameSize, int format, int a_iFrameNo);
  frame(double time, uint8_t *ybuffer, uint8_t *ubuffer, uint8_t *vbuffer, 
	    int *linesize, int width, int height, int a_iFrameNo);
  frame(double time, char *ybuffer, char *ubuffer, char *vbuffer, 
	int width, int height, int frameSize, int format, int a_iFrameNo);

  //copy constructor
  frame(const frame &fr);
  ~frame();

  void DeleteImage();
 
  //Member variables
  int m_iFrameNo; 
  unsigned char *m_pcImage; //The pixel data
  double m_dTimestamp; //In milliseconds (?seconds in MPEG)
  int m_iWidth; //Dimensions in pixels 
  int m_iHeight;
  int m_iFrameSize;  
  int isTransStart; //nonzero if this frame is the POTENTIAL
                    //  start of a transition
  int isTransEnd; //nonzero if this frame is the end of a transition
  int transStartFr; //if isTransEnd, start frame of transition
  transition transType; //if isTransEnd, cut or gradual
  int isKeyFrame;

 private:
  //Member functions

  //Member variables
};



#endif //#ifndef FRAME_H
