#ifndef MPEGDECODER_H
#define MPEGDECODER_H

extern "C" {
#include <ffmpeg/avcodec.h>
#include <ffmpeg/avformat.h>
}

#include "decoder.h"

class MPEG_Decoder : public Decoder
{
public:
  MPEG_Decoder(char* filename);
  ~MPEG_Decoder();

  VideoProperties* GetVideoProperties();
  int GetFrame(frame* &vidframe);
//  int GetAudio(short* buffer, int samples, int channel);
  double GetPercentageDone();

private:
  //ffmpeg data structures for the MPEG stream
  AVFormatContext *pFormatCtx;
  int             i, videoStream;
  int             audioStream, nbAudioStreams;
  AVCodecContext  *pVCodecCtx;
  AVCodecContext  *pACodecCtx;
  AVCodec         *pVCodec, *pACodec;

  VideoProperties *vidprops;
  frame* currframe;
  int frameno;
};

#endif //#ifndef MPEGDECODER_H
