#ifndef SBDVIDPROCESS_H
#define SBDVIDPROCESS_H

#include "vidprocess.h"
#include "frame.h"
#include "histogram.h"

#include <deque>
#include <iostream>
#include <cstring>
#include <cstdlib>

using namespace std;

#define MAX(a,b) (a>b) ? (a) : (b)

class SBD_VidProcess : public VidProcess
{
public:
  SBD_VidProcess(double mthresh, double lthresh, char *dnlogfilename);
  ~SBD_VidProcess();
  void ProcessFrame(frame* vidframe);
  frame* GetFrame();
  void RemoveFrame();
  void EndOfStream();
  int IsFrameReady();

private:
  void CreateHistogram(frame *vidframe);
  void CalculateAllDistances(int ref);
  void CalculateDistance(int ref, int offset);
  void CalculateDn(int frameNo);
  transition CheckForShotChange(int ref);
  transition CheckForCut(int ref);
  transition CheckForGrad(int ref);

  deque<frame> frameQ;
  deque<Histogram> histQ;
  double gradthresh, mainthresh, D8thresh;
  int transPending, transStart, transSavedStart;
  int prevEnd; // end of the previous transition
  int isEndOfStream;
  int shotNo;
  FILE *fdnLog;
};

#endif //#ifndef SBDVIDPROCESS_H
